'use strict';

exports.__esModule = true;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _dialog = require('material-ui/lib/dialog');

var _dialog2 = _interopRequireDefault(_dialog);

var _flatButton = require('material-ui/lib/flat-button');

var _flatButton2 = _interopRequireDefault(_flatButton);

var _reactCodemirror = require('react-codemirror');

var _reactCodemirror2 = _interopRequireDefault(_reactCodemirror);

var _jsBeautify = require('js-beautify');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

require('codemirror/mode/htmlmixed/htmlmixed');

var CodeMirror = function (_Component) {
    _inherits(CodeMirror, _Component);

    function CodeMirror(props) {
        _classCallCheck(this, CodeMirror);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(CodeMirror).call(this, props));

        _this.beautifyOptions = {
            "wrap_line_length": 140
        };
        if (_this.props.node) {
            _this.state = {
                sourceEditorActive: false
            };
        } else {
            _this.state = {};
        }
        return _this;
    }

    _createClass(CodeMirror, [{
        key: 'updateCode',
        value: function updateCode(newCode) {
            this.code = newCode;
        }
    }, {
        key: 'onSave',
        value: function onSave() {
            this.props.updatePiece && this.props.updatePiece(this.props.id, { data: { html: this.code } });
            this.props.savePiece && this.props.savePiece(this.props.id);
            this.setState({ sourceEditorActive: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var customContentStyle = {
                width: '80%',
                maxWidth: 'none'
            };
            var options = {
                lineNumbers: true,
                mode: 'htmlmixed'
            };
            var codemirror = null;

            if (!this.state.sourceEditorActive && this.props.node) {
                codemirror = _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: this.props.data.html },
                    onClick: function onClick(e) {
                        e.preventDefault();_this2.setState({ sourceEditorActive: true });
                    } });
            } else {
                var actions = [_react2.default.createElement(_flatButton2.default, { label: 'Cancel', secondary: true,
                    onClick: function onClick() {
                        return _this2.props.node ? _this2.setState({ sourceEditorActive: false }) : _this2.props.onClose && _this2.props.onClose();
                    }
                }), _react2.default.createElement(_flatButton2.default, { label: 'Save', primary: true, keyboardFocused: true,
                    onClick: function onClick() {
                        return _this2.props.node ? _this2.onSave() : _this2.props.onSave && _this2.props.onSave(_this2.code);
                    }
                })];
                codemirror = _react2.default.createElement(
                    _dialog2.default,
                    { title: 'Edit Source code here', actions: actions, modal: true, open: true,
                        contentStyle: customContentStyle },
                    _react2.default.createElement(_reactCodemirror2.default, {
                        value: (0, _jsBeautify.html)(this.props.node ? this.props.data.html : this.props.html, this.beautifyOptions),
                        onChange: this.updateCode.bind(this), options: options })
                );
            }
            return _react2.default.createElement(
                'div',
                null,
                codemirror
            );
        }
    }]);

    return CodeMirror;
}(_react.Component);

exports.default = CodeMirror;